/* CoolTran, traductor de trminos.
 * 
 * Copyright (C) 2007
 *
 * Authors: Javier Garca Palacios <jgarcia1709@gmail.com>
 *          Diego Sevillano de Miguel <sevas85@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 */

import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.io.File;
import java.io.IOException;
import java.net.URL;
import javax.swing.JPanel;




public class PestanaBusqueda extends JPanel{
	
	
	private static final long serialVersionUID = 1L;
	
	//Declaramos los atributos de la clase
	
	Etiqueta etiquetaValorar= null;
	Etiqueta etiquetaValorar2= null;
	Etiqueta etiquetaMensaje= null;
	Etiqueta etiquetaDiccionario= null;
	
	//	Boton
	 
	 Boton botonBuscar = null;
	 
	 //Desplegable
	 
	 Desplegable desplegableValorarValor = null; 
	 Desplegable desplegableValorarNum = null; 
	 Desplegable desplegableTipoDic = null;
	 
	 //CampoTexto
	 CampoTexto campoTextoBusqueda = null;
	 
	 //ScrollPane
	 
	 ScrollPane scrollPaneBusqueda = null;
	 
		

	public PestanaBusqueda() {
		
		
		this.setLayout(null);
		this.setFont(new Font("Dialog", Font.PLAIN, 14));
		this.setBackground(new Color(Integer.valueOf(Configuracion.propiedades.getProperty("colorprima1")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima2")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima3"))));
		this.setForeground(new Color(51, 51, 51));
		
		//Aado los labels
		
		getLabels();
			
		
		//Aado el Boton
		
		getBoton();
		
		//Aado los Desplegables
		
		getDesplegable();
		
		//Aado el CampoTexto
		
		getCampoTexto();	
		
		// Aado al panel botones y todo lo demas
		
		getScrollPane();

	}
	
	private void getLabels(){
		
		
		etiquetaValorar = new Etiqueta(10, 222, 180, 23, "l_valorar" );
		etiquetaValorar2 = new Etiqueta(190, 222, 50, 23, "l_valorar2" );
		etiquetaMensaje = new Etiqueta(10, 275, 250, 26 );
		etiquetaMensaje.setText("CoolTran");
        etiquetaMensaje.setForeground(Color.black);
        etiquetaDiccionario = new Etiqueta(205, 275, 100, 26, "dicLocDefault",10 );
        etiquetaDiccionario.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
		
		//Aado los labels
		
		this.add(etiquetaValorar, null);
		this.add(etiquetaValorar2, null);
		this.add(etiquetaMensaje, null);
		this.add(etiquetaDiccionario, null);
					
	}
	
	private void getScrollPane() {
		
		scrollPaneBusqueda = new ScrollPane();
		this.add(scrollPaneBusqueda,null);

	}

	
	private void getCampoTexto(){
		 
		campoTextoBusqueda = new CampoTexto(10, 15, 135, 22);
			
		this.add(campoTextoBusqueda,null);
	 }
	
	 private void getDesplegable(){
		 
		 desplegableValorarValor = new Desplegable(230, 222, 72, 22);
		 desplegableValorarNum = new Desplegable(140, 222, 43, 22);
		 desplegableTipoDic = new Desplegable(232, 15, 70, 22);
		 desplegableTipoDic.addItem(Configuracion.messages.getString("combo_local"));
	
			
		//aado al panel
		
		this.add(desplegableValorarValor, null);
		this.add(desplegableValorarNum, null);
		this.add(desplegableTipoDic, null);
			
		 
	 }
	
	private void getBoton(){
		
		//Aado boton
		botonBuscar = new Boton(151, 15, 75, 22,"b_buscar",2);
	
		this.add(botonBuscar,null);
}
		
	public void configurarEventosPestana(final Configuracion config, final Aplicacion aplicacion ){
	
		desplegableTipoDic.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {

		
				if(String.valueOf(desplegableTipoDic.getSelectedItem()).equals(Configuracion.messages.getString("combo_local"))){

					config.cambiaTipoDic("Local");					
					etiquetaValorar.setVisible(false);
					desplegableValorarValor.setVisible(false);
					desplegableValorarNum.setVisible(false);
					etiquetaValorar2.setVisible(false);
					etiquetaDiccionario.setText(Configuracion.propiedades.getProperty("dicLocDefault"));
				}else{

					config.cambiaTipoDic("Colaborativo");
					etiquetaValorar.setVisible(true);
					desplegableValorarValor.setVisible(true);
					desplegableValorarNum.setVisible(true);
					etiquetaValorar2.setVisible(true);
					etiquetaDiccionario.setText(String.valueOf(config.arrayWikiInstall.get(Integer.valueOf(Configuracion.propiedades.getProperty("indiceColaborativo")))));
				}
				//cambia tipo dic tb en tray (si esta en windows claro)
				
		     	aplicacion.creaTray();
				
			}	
	    });
	  
		campoTextoBusqueda.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent ke) {
				Termino term =null;
				if (ke.getKeyCode() == KeyEvent.VK_ENTER) {
					
					term = aplicacion.buscarTermino(campoTextoBusqueda.getText(),false);
					setTraduccion(term);				
				}	
			}
		}); 
		
		botonBuscar.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent ke) {
				Termino term =null;
				if (ke.getKeyCode() == KeyEvent.VK_ENTER) {
					
					term = aplicacion.buscarTermino(campoTextoBusqueda.getText(),false);
					setTraduccion(term);
				}
			}
		});
		
		botonBuscar.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				Termino term =null;
				term = aplicacion.buscarTermino(campoTextoBusqueda.getText(),false);
				setTraduccion(term);
			}		
		});	
		
		desplegableValorarValor.addActionListener(new ActionListener() {		
			public void actionPerformed(ActionEvent arg0) {

				// TODO Auto-generated method stub
				int valor = desplegableValorarValor.getSelectedIndex();
				int valorValorar = desplegableValorarNum.getSelectedIndex();
				Boolean valido = false;
				if(desplegableValorarNum.getItemCount() > 0 ){
						valido = aplicacion.valorarTermino(valor , valorValorar);
						
			
						if (valido){
							etiquetaMensaje.setText(Configuracion.messages.getString("msj_valoracion"));
						}else{
							etiquetaMensaje.setText(Configuracion.messages.getString("msj_errorvaloracion"));
						}
				}
								
			}
		});
	  
	}
	
	public void cambiarColorInterfaz(){
		
		this.setBackground(new Color(Integer.valueOf(Configuracion.propiedades.getProperty("colorprima1")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima2")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima3"))));
		desplegableValorarValor.cambiarColorInterfaz();
		desplegableValorarNum.cambiarColorInterfaz();
		desplegableTipoDic.cambiarColorInterfaz();
		botonBuscar.cambiarColorInterfaz();
		campoTextoBusqueda.cambiarColorInterfaz();
		
	}
	
	public void cambiarIdiomaInterfaz(){
		
		//cambiamos las etiquetas
		etiquetaValorar.cambiarIdiomaInterfaz();
		etiquetaValorar2.cambiarIdiomaInterfaz();

		
		//cambiamos los botones
		botonBuscar.cambiarIdiomaInterfaz();
		
		//cambiamos el idioma de los desplegables
		desplegableValorarValor.removeAllItems();
		for (int i = 1; i < 4 ; i++) {
			desplegableValorarValor.addItem(Configuracion.messages.getString("l_valorar_desp_"+i));
		
		//desplegableTipoDic.removeItem("Local");
		//desplegableTipoDic.removeItem("Lokal");
		//desplegableTipoDic.addItem(Configuracion.messages.getString("combo_local"));
		
			
		}
	}
	
	public void setTraduccion(Termino term){
		
		if (term.getTipo().equals("Local")){
			scrollPaneBusqueda.panelTextoScroll.setText(term.getTraduccion());				
		}
		
		if (term.getTipo().equals("Colaborativo")){

			try {
				
				File file = new File(term.getTraduccion());
				URL toURL = file.toURL();
				java.net.URL url = toURL; 
				scrollPaneBusqueda.panelTextoScroll.setPage(url);
				file.deleteOnExit();
						
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}		

}
