/* CoolTran, traductor de trminos.
 * 
 * Copyright (C) 2007
 *
 * Authors: Javier Garca Palacios <jgarcia1709@gmail.com>
 *          Diego Sevillano de Miguel <sevas85@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 */

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import javax.swing.JFileChooser;
import javax.swing.JPanel;





public class PestanaDiccionarios extends JPanel{
	
	
	private static final long serialVersionUID = 1L;
	
	//Declaramos los atributos de la clase
	
	//Etiquetas
	Etiqueta etiquetaDicWiki= null;
	Etiqueta etiquetaDicLocal= null;
	Etiqueta etiquetaDicInstalar= null;
	
	//Desplegables
	
	 Desplegable desplegableDicWiki = null;
	 Desplegable desplegableDicLocal = null;
	 
	 //Botones
	 
	 Boton botonInstalarDic = null; 


	public PestanaDiccionarios() {
		
		
		
		this.setLayout(null);
        this.setBackground(new Color(Integer.valueOf(Configuracion.propiedades.getProperty("colorprima1")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima2")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima3"))));
        this.setPreferredSize(new Dimension(97, 140));
        this.setVisible(true);
        
		getLabels();
		
					
		// Aado los botones
		
		getBoton();
		
		//Aado los Desplegables
		
		getDesplegable();
	}
	
	private void getLabels(){
		
		
     
		etiquetaDicWiki = new Etiqueta(10, 15, 177, 26, "l_diccolab" );
		etiquetaDicLocal = new Etiqueta(10, 75, 197, 24, "l_diccinst" );
		etiquetaDicInstalar = new Etiqueta(20, 175, 290, 26, "l_instadicc" );
        
              
        //Aado los labels
		
		this.add(etiquetaDicWiki, null);
		this.add(etiquetaDicLocal, null);
		this.add(etiquetaDicInstalar, null);
		
			
		
	}
	
	 private void getDesplegable(){
		 
		 desplegableDicLocal = new Desplegable(220, 75, 83, 24);
		 desplegableDicWiki = new Desplegable(190, 15, 112, 24);
		 desplegableDicWiki.setMaximumRowCount(14);


			
		//aado al panel
		
		this.add(desplegableDicLocal, null);
		this.add(desplegableDicWiki, null);
			
		 
	 }
	
	 
	private void getBoton(){
			
			//Aado boton
			botonInstalarDic = new Boton(51, 145, 209, 26,"b_instadicc",2);
		
			this.add(botonInstalarDic,null);
	}
	
	public void configurarEventosPestana(final Configuracion config, final PestanaBusqueda pestana1, final Aplicacion aplicacion, final Ventana controlador ){
		
		
				desplegableDicLocal.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				config.cambiarDiccionario(String.valueOf(desplegableDicLocal.getSelectedItem()));
				if (Configuracion.propiedades.getProperty("tipoDic").equals("Local")){
					pestana1.etiquetaDiccionario.setText(Configuracion.propiedades.getProperty("dicLocDefault"));
				}
				//cambia diccionario tb en tray (si esta en windows claro)
				aplicacion.creaTray();
				
				if (!pestana1.campoTextoBusqueda.getText().equals(""))
					aplicacion.buscarTermino(pestana1.campoTextoBusqueda.getText(),false);
			}	
	    });
		  
		
	
	       botonInstalarDic.addMouseListener(new java.awt.event.MouseAdapter() {
		public void mouseClicked(java.awt.event.MouseEvent e) {
			JFileChooser fileChooser = new JFileChooser();
			//Creamos el filtro para ver solo archivos .java
			fileChooser.setFileFilter(new javax.swing.filechooser.FileFilter ()
			{
			//Esta funcion es la que mostrara los archivos
			//con la extension que quieres y los directorios
			public boolean accept (File file)
			{
			String filename = file.getName();
			return (filename.endsWith(".properties") || file.isDirectory());
			}
			//Esta funcion muestra el texto en la lista de opciones de ficheros para ver
			public String getDescription()
			{
			return "Archivos de diccionario (*.properties)";
			}
			});
			int seleccion = fileChooser.showOpenDialog(controlador);
			if (seleccion == JFileChooser.APPROVE_OPTION)
			{
			   File fichero = fileChooser.getSelectedFile();
			   // y a trabajar con fichero ....
			   File dst = new File("diccionarios/"+fichero.getName());
			   
			   try{ 
		       InputStream in = new FileInputStream(fichero);
		       OutputStream out = new FileOutputStream(dst);
		       
		       //Algoritmo de copia de ficheros
		       byte[] buf = new byte[1024];
		       int len;
		       while ((len = in.read(buf)) > 0) {
		           out.write(buf, 0, len);
		       }
		       in.close();
		       out.close(); 
		       //fin copia
		       
		       }catch(Exception ex){
		    	   System.out.println(e);
		       }
			}
		}		
	});
	
	       desplegableDicWiki.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e) {
			
			
			config.cambiaDicColab(String.valueOf(desplegableDicWiki.getSelectedItem()));
			config.cambiaIndiceColab(String.valueOf(desplegableDicWiki.getSelectedIndex()));
						
			//cambia diccionario tb en tray (si esta en windows claro)
			aplicacion.accionCambiarDiccionario();
			

		}
    });


	}    
	
	public void cambiarColorInterfaz(){
		this.setBackground(new Color(Integer.valueOf(Configuracion.propiedades.getProperty("colorprima1")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima2")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima3"))));
		desplegableDicWiki.cambiarColorInterfaz();
		desplegableDicLocal.cambiarColorInterfaz();
		botonInstalarDic.cambiarColorInterfaz();

	}
	
	public void cambiarIdiomaInterfaz(){
		
		//cambiamos las etiquetas
		etiquetaDicWiki.cambiarIdiomaInterfaz();
		etiquetaDicLocal.cambiarIdiomaInterfaz();
		etiquetaDicInstalar.cambiarIdiomaInterfaz();
		
		//cambiamos los botones
		botonInstalarDic.cambiarIdiomaInterfaz();
	}
	
	
}	

	


