/* CoolTran, traductor de trminos.
 * 
 * Copyright (C) 2007
 *
 * Authors: Javier Garca Palacios <jgarcia1709@gmail.com>
 *          Diego Sevillano de Miguel <sevas85@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 */

import java.awt.Color;
import java.awt.Rectangle;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import javax.swing.JPanel;

public class PestanaWikiRegistro<Jpanel> extends JPanel{
		
	Etiqueta etiquetaMensajeReg= null;
	Etiqueta etiquetaUsuario= null;
	Etiqueta etiquetaPassword= null;
	Etiqueta etiquetaCorreo=null;
	Etiqueta etiquetaSO = null;
	
	//Campo Texto
	
	CampoTexto campoTextoCorreo = null;
	CampoTexto campoTextoSO = null;
	CampoTexto campoTextoUsuario = null;
	
	//Boton
	
	Boton botonRegistrar = null;
	Boton botonSalir = null;
		
	//Campo Contrasea
	
	CampoContrasena campoContrasenaReg = null;
	
	private static final long serialVersionUID = 1L;
	  	
	 public PestanaWikiRegistro(){
	 	 
		 		// Configuro el Panel
			
				this.setLayout(null);				
				this.setBounds(new Rectangle(0, 0, 320, 360));
				this.setBackground(new Color(Integer.valueOf(Configuracion.propiedades.getProperty("colorprima1")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima2")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima3"))));
				
				 //Aado las etiquetas
				
				getLabels();
				
				 //Aado Los CampoTexto
				
				getCampoTexto();
				
				 //Aado los Botones
				
				getBoton();
				
				 //Aado las Campo Contrsena
				
				getCampoContrasena();
						

				//Configuro la visibilidad
				
				etiquetaCorreo.setVisible(false);
				etiquetaSO.setVisible(false);
				campoTextoCorreo.setVisible(false);
				campoTextoSO.setVisible(false);
				botonSalir.setVisible(false);
											
	}
	 	 
		private void getLabels(){					
					
					etiquetaMensajeReg = new Etiqueta(10, 280, 300, 16);
					etiquetaMensajeReg.setText("");
					etiquetaUsuario = new Etiqueta(10, 51, 130, 22, "l_usuario" );
					etiquetaPassword = new Etiqueta(10, 84, 130, 22, "l_pass");
					etiquetaCorreo = new Etiqueta(10, 130, 130, 22, "l_correo" );
					etiquetaSO = new Etiqueta(10, 163, 130, 22, "l_so" );
							    		
		    		//Aado los labels
		    		
		    		this.add(etiquetaMensajeReg, null);
		    		this.add(etiquetaUsuario, null);
		    		this.add(etiquetaPassword, null);
		    		this.add(etiquetaCorreo, null);
		    		this.add(etiquetaSO, null);
		    		       			
			}
		
		private void getCampoTexto(){
			
			campoTextoCorreo = new CampoTexto(150, 130, 130, 20);
			campoTextoSO = new CampoTexto(150, 163, 130, 20);
			campoTextoUsuario = new CampoTexto(150, 51, 130, 20);
			
			this.add(campoTextoCorreo,null);
			this.add(campoTextoSO,null);
			this.add(campoTextoUsuario,null);
				
		}
		
		private void getCampoContrasena(){
			
			campoContrasenaReg = new CampoContrasena(150, 84, 130, 20);		
			this.add(campoContrasenaReg,null);
		
		}
		
		
		
		private void getBoton(){
			
		
			//Aado boton
			botonRegistrar = new Boton(120, 220, 100, 20,"b_registrar",2);
			botonSalir = new Boton(255, 10, 50, 20,"b_salir",2);
						
			this.add(botonRegistrar,null);
			this.add(botonSalir,null);
		
		}
		
		public void configurarEventosPestana(final Ventana controlador, final Aplicacion aplicacion){
					 			 
		//Salir del Registro
			
			botonSalir.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
					campoTextoUsuario.setEditable(true);
					campoContrasenaReg.setEditable(true);
					campoTextoUsuario.setText("");
					campoContrasenaReg.setText("");
					etiquetaMensajeReg.setText("");
					etiquetaCorreo.setVisible(false);
					etiquetaSO.setVisible(false);
					campoTextoCorreo.setVisible(false);
					campoTextoSO.setVisible(false);
					botonSalir.setVisible(false);
					
					controlador.panelInicial.panelPestanas.pestana4.panelAnadir.setVisible(false);
					controlador.panelInicial.panelPestanas.pestana4.panelRegistrar.setVisible(true);			
			}		
		});
		
		
			campoContrasenaReg.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent ke) {
				String usuario = "";
				String pass = "";
				if (ke.getKeyCode() == KeyEvent.VK_ENTER) {
					
					usuario = campoTextoUsuario.getText();
					pass = String.valueOf(campoContrasenaReg.getPassword());
					aplicacion.identificarUsuario(usuario, pass);
							
				}
			}
		});
		
		
		botonRegistrar.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent ke) {
				String usuario = "";
				String pass = "";
				if (ke.getKeyCode() == KeyEvent.VK_ENTER) {
					
					usuario = campoTextoUsuario.getText();
					pass = String.valueOf(campoContrasenaReg.getPassword());
					aplicacion.identificarUsuario(usuario, pass);
							
				}
			}
		});
			
		
		botonRegistrar.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				String usuario = "";
				String pass = "";
					
				usuario = campoTextoUsuario.getText();
				pass = String.valueOf(campoContrasenaReg.getPassword());
				aplicacion.identificarUsuario(usuario, pass);
							
				
			}		
		});
		
		}
		
		public void cambiarColorInterfaz(){
			
			this.setBackground(new Color(Integer.valueOf(Configuracion.propiedades.getProperty("colorprima1")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima2")), Integer.valueOf(Configuracion.propiedades.getProperty("colorprima3"))));
			botonRegistrar.cambiarColorInterfaz();
			botonSalir.cambiarColorInterfaz();
			campoContrasenaReg.cambiarColorInterfaz();
			campoTextoCorreo.cambiarColorInterfaz();
			campoTextoSO.cambiarColorInterfaz();
			campoTextoUsuario.cambiarColorInterfaz();
		}
		
		public void cambiarIdiomaInterfaz(){
			
			//cambiamos las etiquetas

			etiquetaUsuario.cambiarIdiomaInterfaz();
			etiquetaPassword.cambiarIdiomaInterfaz();
			etiquetaCorreo.cambiarIdiomaInterfaz();
			etiquetaSO.cambiarIdiomaInterfaz();
			
			//cambiamos los botones
			botonRegistrar.cambiarIdiomaInterfaz();
			botonSalir.cambiarIdiomaInterfaz();
		}
			
	
}	


