/* CoolTran, traductor de trminos.
 * 
 * Copyright (C) 2007
 *
 * Authors: Javier Garca Palacios <jgarcia1709@gmail.com>
 *          Diego Sevillano de Miguel <sevas85@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 */

import java.sql.*;
import java.text.SimpleDateFormat;



public class Usuario {
	
	String cadUsuario="";
	String cadContrasena="";
	Ventana ventanaControl = null;
	Connection con = null;

	Statement stmt = null;
	Statement stmt2 = null;
	ResultSet res = null;
	ResultSet res2 = null;
	
	private PestanaWikiRegistro pestanaRegistrar = null;
	private PestanaWikiAnadir pestanaAnadir = null;
	
	public  Usuario(String name, String password, Ventana controlador, Conexion conexion){
		cadUsuario = name;
		cadContrasena = password;
		ventanaControl = controlador;
		pestanaRegistrar = ventanaControl.panelInicial.panelPestanas.pestana4.panelRegistrar;
		pestanaAnadir = ventanaControl.panelInicial.panelPestanas.pestana4.panelAnadir;
		con = conexion.con;
		
	}


	public boolean registrarse (){
		String query;
		String fecha="";
		String so = "";
		String correo = "";
		
		//recuperamos el valor
		
		so = pestanaRegistrar.campoTextoSO.getText();
		correo = pestanaRegistrar.campoTextoCorreo.getText();
		
		
		
		if (!so.equals("") && !correo.equals("")){
		
						SimpleDateFormat formato1 = new SimpleDateFormat("yyyyMMddHHmmss");
						fecha = formato1.format(System.currentTimeMillis());
						
						query =" insert into  `usuarios` values ( '"+cadUsuario+"' , '"+cadContrasena+"' , '"+fecha+"', '"+correo+"','"+so+"' )" ;
							
						try {		
								stmt =(Statement) con.createStatement();
								stmt.executeUpdate(query);
				
								pestanaRegistrar.etiquetaMensajeReg.setText(Configuracion.messages.getString("msj_registrausuario"));
								return true;
							
						} catch (SQLException e) {
								e.printStackTrace();
						}
							
		}else{
			pestanaRegistrar.etiquetaMensajeReg.setText(Configuracion.messages.getString("msj_rellenarcampos"));
			return false;
			
			
		}
			
			
		return true;		
	}
	
	public boolean identificarse(){
		
		String query;
	
		
		query =" select count(*) from usuarios u " +
				" where u.username = '"+cadUsuario+"' " +
				" AND u.password = '"+cadContrasena+"' " ;
		
		try {
			
			
			stmt =(Statement) con.createStatement();
			res = (ResultSet) stmt.executeQuery(query);
			
			
			while (res.next()){
		          
				String usuarioRegi = res.getString(1);
				
				if (usuarioRegi.equals("1")){
					pestanaRegistrar.etiquetaMensajeReg.setText(Configuracion.messages.getString("msj_identificausuario"));	
					almacenarUsuarioConfig(cadUsuario,cadContrasena);
					return true;
					
				}else if (usuarioRegi.equals("0")){
							
							query =" select count(*) from usuarios u " +
									" where u.username = '"+cadUsuario+"' ";
							
							stmt2 =(Statement) con.createStatement();
							res2 = (ResultSet) stmt2.executeQuery(query);
							
							while (res2.next()){
								
								usuarioRegi = res2.getString(1);
													
								if (usuarioRegi.equals("1")){
									pestanaRegistrar.etiquetaMensajeReg.setText(Configuracion.messages.getString("msj_passincorrecta"));
									pestanaRegistrar.campoContrasenaReg.setText("");
									
								}else if (usuarioRegi.equals("0")){
										
										
									
									if (pestanaRegistrar.etiquetaCorreo.isVisible()){
										if (registrarse()){
											return true;
										}else{
											return false;
										}
									}else{
											//	Los ponemos en solo Lectura
										pestanaRegistrar.campoContrasenaReg.setEditable(false);
										pestanaRegistrar.campoTextoUsuario.setEditable(false);
										pestanaRegistrar.etiquetaMensajeReg.setText(Configuracion.messages.getString("msj_usuarionoexiste"));
									}
									
									pestanaRegistrar.etiquetaCorreo.setVisible(true);
									pestanaRegistrar.etiquetaSO.setVisible(true);
									pestanaRegistrar.campoTextoCorreo.setVisible(true);
									pestanaRegistrar.campoTextoSO.setVisible(true);
									pestanaRegistrar.botonSalir.setVisible(true);
								}
							}
				}
			}
		
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return false;
	
	}
	
	public void almacenarUsuarioConfig(String usu,String contra){
		Configuracion.propiedades.setProperty("usuario", usu);
		Configuracion.propiedades.setProperty("password", contra);
	}
	
	
	public boolean anadirTermino(String w_tabla, String radio ){
		
		//asignamos de nuevo el control por que la ventana ha sido modificada
	
		
		//Primero recogemos los valores 
			
		String query="";
		String fecha="";
		
		
		String termino = pestanaAnadir.campoTextoTermino.getText();		
		String traduccion = pestanaAnadir.panelTextoTraduccion.getText();
						
		
		SimpleDateFormat formato1 = new SimpleDateFormat("yyyyMMddHHmmss");
		
		fecha = formato1.format(System.currentTimeMillis());
		
		
		query=" INSERT INTO termino ( TERM , TRADUCCION, TIPO, USERNAME, FECHA , NOMBRE ) VALUES ('"+termino+"', '"+traduccion+"',"+radio+",'"+cadUsuario+"','"+fecha+"','"+w_tabla+"'  )";

			
			try {

				stmt = con.createStatement();
				stmt.executeUpdate(query);
				pestanaAnadir.jLabelMensajeAnadir.setText(Configuracion.messages.getString("l_insertar"));
					
				}catch(Exception e){
					System.out.println("Excepcion insertando");
				}
		return true;
	}

}
